package cn.wzpmc.hny.commands.hny.arguments;

import cn.wzpmc.hny.pojo.CustomItem;
import com.mojang.brigadier.LiteralMessage;
import com.mojang.brigadier.StringReader;
import com.mojang.brigadier.arguments.ArgumentType;
import com.mojang.brigadier.context.CommandContext;
import com.mojang.brigadier.exceptions.CommandSyntaxException;
import com.mojang.brigadier.exceptions.SimpleCommandExceptionType;
import com.mojang.brigadier.suggestion.Suggestions;
import com.mojang.brigadier.suggestion.SuggestionsBuilder;

import java.util.concurrent.CompletableFuture;

public class CustomItemArgumentType implements ArgumentType<CustomItem> {
    @Override
    public CustomItem parse(StringReader stringReader) throws CommandSyntaxException {
        String s = stringReader.readUnquotedString();
        int itemId;
        try {
            itemId = Integer.parseInt(s);
        }catch (NumberFormatException e){
            LiteralMessage message = new LiteralMessage("输入的不是数字！");
            throw new CommandSyntaxException(new SimpleCommandExceptionType(message), message);
        }
        CustomItem customItem = CustomItem.ItemStatic.items.get(itemId);
        if (customItem == null){
            LiteralMessage message = new LiteralMessage("物品不存在！");
            throw new CommandSyntaxException(new SimpleCommandExceptionType(message), message);
        }
        return customItem;
    }
    @Override
    public <S> CompletableFuture<Suggestions> listSuggestions(CommandContext<S> context, SuggestionsBuilder builder) {
        for (Integer integer : CustomItem.ItemStatic.items.keySet()) {
            builder.suggest(integer);
        }
        return builder.buildFuture();
    }
}
