package cn.wzpmc.hny.commands.hny.sub.armor;

import cn.wzpmc.hny.games.PlayerDataManager;
import cn.wzpmc.hny.pojo.GlobalPlayerData;
import com.mojang.brigadier.Command;
import com.mojang.brigadier.context.CommandContext;
import com.mojang.brigadier.exceptions.CommandSyntaxException;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

public class ArmorUpgrade implements Command<CommandSender> {
    private final boolean isHead;
    private final boolean isShield;
    public ArmorUpgrade(boolean isHead, boolean isShield){
        this.isHead = isHead;
        this.isShield = isShield;
    }
    @Override
    public int run(CommandContext<CommandSender> commandContext) throws CommandSyntaxException {
        Player source = (Player) commandContext.getSource();
        PlayerDataManager instance = PlayerDataManager.getInstance();
        GlobalPlayerData playerData = instance.getPlayerData(source);
        double money = playerData.getMoney();
        if (isShield) {
            if (playerData.isShield()){
                source.sendMessage(Component.text("你已经有盾牌了").color(NamedTextColor.YELLOW));
                return 0;
            }
            if (money > 30){
                playerData.reduceMoney(30);
                playerData.setShield(true);
                instance.savePlayerData(source);
                return 0;
            }else {
                source.sendMessage(Component.text("余额不足~").color(NamedTextColor.YELLOW));
            }
            return 0;
        }
        if (isHead){
            int armorHeadLevel = playerData.getArmorHeadLevel();
            if (armorHeadLevel == 0){
                if (money > 15){
                    playerData.reduceMoney(15);
                    playerData.addArmorHeadLevel();
                    instance.savePlayerData(source);
                } else {
                    source.sendMessage(Component.text("余额不足~").color(NamedTextColor.YELLOW));
                }
            }else {
                if (money > 20){
                    if (playerData.getArmorHeadLevel() >= 5){
                        source.sendMessage(Component.text("当前护甲已经为顶级").color(NamedTextColor.GOLD));
                        return 0;
                    }
                    playerData.reduceMoney(20);
                    playerData.addArmorHeadLevel();
                    instance.savePlayerData(source);
                } else {
                    source.sendMessage(Component.text("余额不足~").color(NamedTextColor.YELLOW));
                }
            }
            //15 20
        }else {
            int armorLegLevel = playerData.getArmorLegLevel();
            if (armorLegLevel == 0){
                if (money > 20){
                    playerData.reduceMoney(20);
                    playerData.addArmorLegLevel();
                    instance.savePlayerData(source);
                } else {
                    source.sendMessage(Component.text("余额不足~").color(NamedTextColor.YELLOW));
                }
            }else {
                if (money > 30){
                    playerData.reduceMoney(30);
                    playerData.addArmorLegLevel();
                    instance.savePlayerData(source);
                    if (playerData.getArmorHeadLevel() >= 5){
                        source.sendMessage(Component.text("当前护甲已经为顶级").color(NamedTextColor.GOLD));
                        return 0;
                    }
                } else {
                    source.sendMessage(Component.text("余额不足~").color(NamedTextColor.YELLOW));
                }
            }
        }
        return 0;
    }
}
