package cn.wzpmc.hny.commands.hny.sub.buy;

import cn.wzpmc.hny.games.PlayerDataManager;
import cn.wzpmc.hny.pojo.CustomItem;
import cn.wzpmc.hny.pojo.GlobalPlayerData;
import com.mojang.brigadier.Command;
import com.mojang.brigadier.context.CommandContext;
import com.mojang.brigadier.exceptions.CommandSyntaxException;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import java.util.HashMap;
import java.util.Map;

import static cn.wzpmc.hny.pojo.CustomItem.ItemStatic.*;

public class BuyCommand implements Command<CommandSender> {
    public static final Map<CustomItem, Double> prices = new HashMap<>();
    static {
        prices.put(DISH, 30d);
        prices.put(HEART, 20d);
        prices.put(STRENGTH, 40d);
        prices.put(BADLY_HURT, 20d);
        prices.put(TOTEM_OF_UNDYING, 60d);
        prices.put(TREAT, 10d);
        prices.put(TURBINE, 15d);
        prices.put(MILK, 10d);
        prices.put(EVOLUTION_CRYSTAL, 40d);
        prices.put(PILL, 15d);
        prices.put(PUT_OFF, 50d);
        prices.put(CODE, 35d);
        prices.put(SEED, 30d);
    }
    @Override
    public int run(CommandContext<CommandSender> commandContext) throws CommandSyntaxException {
        CustomItem item = commandContext.getArgument("item", CustomItem.class);
        CommandSender source = commandContext.getSource();
        Player player = (Player) source;
        PlayerDataManager instance = PlayerDataManager.getInstance();
        GlobalPlayerData playerData = instance.getPlayerData(player);
        double money = playerData.getMoney();
        Double price = prices.get(item);
        if (money > price){
            playerData.reduceMoney(price);
            playerData.addItem(item);
            source.sendMessage(Component.text("购买成功！").color(NamedTextColor.GREEN));
        }else {
            source.sendMessage(Component.text("余额不足").color(NamedTextColor.GOLD));
        }
        instance.savePlayerData(player);
        return 0;
    }
}
