package cn.wzpmc.hny.commands.hny.sub.buy;

import cn.wzpmc.hny.pojo.CustomItem;
import com.mojang.brigadier.Command;
import com.mojang.brigadier.context.CommandContext;
import com.mojang.brigadier.exceptions.CommandSyntaxException;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.JoinConfiguration;
import net.kyori.adventure.text.event.ClickEvent;
import net.kyori.adventure.text.event.HoverEvent;
import net.kyori.adventure.text.format.NamedTextColor;
import net.kyori.adventure.text.format.TextDecoration;
import org.bukkit.command.CommandSender;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public class BuyMenuCommand implements Command<CommandSender> {
    @Override
    public int run(CommandContext<CommandSender> commandContext) throws CommandSyntaxException {
        CommandSender source = commandContext.getSource();
        source.sendMessage(Component.text("可购买的物品有：").color(NamedTextColor.GOLD).decorate(TextDecoration.BOLD));
        for (Map.Entry<CustomItem, Double> integerCustomItemEntry : BuyCommand.prices.entrySet()) {
            CustomItem item = integerCustomItemEntry.getKey();
            Double price = integerCustomItemEntry.getValue();
            for (Map.Entry<Integer, CustomItem> customItemEntry : CustomItem.ItemStatic.items.entrySet()) {
                if (customItemEntry.getValue().equals(item)) {
                    Component displayName = item.getDisplayName();
                    List<Component> hoverText = new ArrayList<>();
                    hoverText.add(displayName);
                    List<Component> lore = item.getLore();
                    hoverText.addAll(lore);
                    hoverText.add(Component.text("售价：" + price + "金币").color(NamedTextColor.GOLD).decorate(TextDecoration.UNDERLINED, TextDecoration.BOLD));
                    displayName = displayName.hoverEvent(HoverEvent.showText(Component.join(JoinConfiguration.newlines(), hoverText)));
                    displayName = displayName.clickEvent(ClickEvent.runCommand("/hny buy " + customItemEntry.getKey()));
                    source.sendMessage(displayName);
                }
            }
        }
        return 0;
    }
}
