package cn.wzpmc.hny.commands.lobby.arguments;

import cn.wzpmc.hny.enums.Aspects;
import com.mojang.brigadier.StringReader;
import com.mojang.brigadier.arguments.ArgumentType;
import com.mojang.brigadier.context.CommandContext;
import com.mojang.brigadier.exceptions.CommandSyntaxException;
import com.mojang.brigadier.suggestion.Suggestions;
import com.mojang.brigadier.suggestion.SuggestionsBuilder;

import java.util.concurrent.CompletableFuture;

public class AspectArgumentType implements ArgumentType<Aspects> {
    @Override
    public Aspects parse(StringReader stringReader) throws CommandSyntaxException {
        String s = stringReader.readUnquotedString();
        return Aspects.valueOf(s.toUpperCase());
    }

    @Override
    public <S> CompletableFuture<Suggestions> listSuggestions(CommandContext<S> context, SuggestionsBuilder builder) {
        builder.suggest("A");
        builder.suggest("B");
        return builder.buildFuture();
    }
}
