package cn.wzpmc.hny.commands.lobby.sub.debug;

import cn.wzpmc.hny.games.enums.Games;
import cn.wzpmc.hny.pojo.BoxPosition;
import com.destroystokyo.paper.ParticleBuilder;
import com.mojang.brigadier.Command;
import com.mojang.brigadier.context.CommandContext;
import com.mojang.brigadier.exceptions.CommandSyntaxException;
import net.kyori.adventure.text.Component;
import org.bukkit.Color;
import org.bukkit.Location;
import org.bukkit.Particle;
import org.bukkit.World;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

public class ShowCommand implements Command<CommandSender> {
    @Override
    public int run(CommandContext<CommandSender> commandContext) throws CommandSyntaxException {
        String stageName = commandContext.getArgument("stageName", String.class);
        Games game = Games.valueOf(stageName.toUpperCase());
        BoxPosition boxPosition = game.getBoxPosition();
        Location pos1 = boxPosition.getPos1();
        Location pos2 = boxPosition.getPos2();
        Player source = (Player) commandContext.getSource();
        World world = source.getWorld();
        source.sendMessage(stageName);
        source.sendMessage("顶点1：");
        source.sendMessage(Component.text(pos1.getX()).appendSpace().append(Component.text(pos1.getY())).appendSpace().append(Component.text(pos1.getZ())));
        source.sendMessage("顶点2：");
        source.sendMessage(Component.text(pos2.getX()).appendSpace().append(Component.text(pos2.getY())).appendSpace().append(Component.text(pos2.getZ())));
        for (Location edgePointPose : boxPosition.getEdgePointPoses()) {
            edgePointPose.setWorld(world);
            new ParticleBuilder(Particle.DUST_COLOR_TRANSITION).data(new Particle.DustTransition(Color.RED, Color.RED, 1)).location(edgePointPose).spawn();
        }
        return 0;
    }
}
