package cn.wzpmc.hny.events;

import cn.wzpmc.hny.games.GameStageManager;
import cn.wzpmc.hny.games.PlayerDataManager;
import cn.wzpmc.hny.games.enums.Games;
import org.bukkit.Server;
import org.bukkit.World;
import org.bukkit.entity.LivingEntity;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.EntityDeathEvent;

import java.util.Set;

public class EntityDeath implements Listener {
    @EventHandler
    public void onEntityDeath(EntityDeathEvent event){
        LivingEntity entity = event.getEntity();
        Set<String> scoreboardTags = entity.getScoreboardTags();
        if (scoreboardTags.stream().anyMatch(e -> e.equals("boss1"))) {
            World world = entity.getWorld();
            if (world.getEntities().stream().noneMatch(e -> e.getScoreboardTags().stream().anyMatch(tag -> tag.equals("boss1")))) {
                GameStageManager.getInstance().triggerGameEnd(Games.GAME2);
            }
        }
        Server server = entity.getServer();
        PlayerDataManager instance = PlayerDataManager.getInstance();
        for (Player onlinePlayer : server.getOnlinePlayers()) {
            instance.getPlayerData(onlinePlayer).addMoney(50);
            instance.savePlayerData(onlinePlayer);
        }
    }
}
