package cn.wzpmc.hny.events;

import cn.wzpmc.hny.games.PlayerDataManager;
import cn.wzpmc.hny.pojo.GlobalPlayerData;
import org.bukkit.GameMode;
import org.bukkit.GameRule;
import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerChangedWorldEvent;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.PlayerInventory;
import org.bukkit.potion.PotionEffect;
import org.bukkit.potion.PotionEffectType;

public class PlayerChangeWorld implements Listener {
    @EventHandler
    public void onPlayerChangeWorld(PlayerChangedWorldEvent event){
        Player player = event.getPlayer();
        World world = player.getWorld();
        if (world.getName().equals("world_the_end")) {
            player.setGameMode(GameMode.SURVIVAL);
            player.addPotionEffect(new PotionEffect(PotionEffectType.SATURATION, 1000000000, 255, true));
            world.setGameRule(GameRule.NATURAL_REGENERATION, false);
            PlayerInventory inventory = player.getInventory();
            PlayerDataManager instance = PlayerDataManager.getInstance();
            GlobalPlayerData playerData = instance.getPlayerData(player);
            Material HEAD, CHEST_PLATE, LEGGING, FEET;
            switch (playerData.getArmorHeadLevel()) {
                case 1:
                    HEAD = Material.LEATHER_HELMET;
                    CHEST_PLATE = Material.LEATHER_CHESTPLATE;
                    LEGGING = Material.LEATHER_LEGGINGS;
                    FEET = Material.LEATHER_BOOTS;
                    break;
                case 2:
                    HEAD = Material.CHAINMAIL_HELMET;
                    CHEST_PLATE = Material.CHAINMAIL_CHESTPLATE;
                    LEGGING = Material.CHAINMAIL_LEGGINGS;
                    FEET = Material.CHAINMAIL_BOOTS;
                    break;
                case 3:
                    HEAD = Material.IRON_HELMET;
                    CHEST_PLATE = Material.IRON_CHESTPLATE;
                    LEGGING = Material.IRON_LEGGINGS;
                    FEET = Material.IRON_BOOTS;
                    break;
                case 4:
                    HEAD = Material.DIAMOND_HELMET;
                    CHEST_PLATE = Material.DIAMOND_CHESTPLATE;
                    LEGGING = Material.DIAMOND_LEGGINGS;
                    FEET = Material.DIAMOND_BOOTS;
                    break;
                case 5:
                    HEAD = Material.NETHERITE_HELMET;
                    CHEST_PLATE = Material.NETHERITE_CHESTPLATE;
                    LEGGING = Material.NETHERITE_LEGGINGS;
                    FEET = Material.NETHERITE_BOOTS;
                    break;
                default:
                    HEAD = Material.AIR;
                    CHEST_PLATE = Material.AIR;
                    LEGGING = Material.AIR;
                    FEET = Material.AIR;
                    break;
            }
            inventory.setHelmet(new ItemStack(HEAD));
            inventory.setChestplate(new ItemStack(CHEST_PLATE));
            inventory.setLeggings(new ItemStack(LEGGING));
            inventory.setBoots(new ItemStack(FEET));
            if (playerData.isShield()){
                inventory.setItemInOffHand(new ItemStack(Material.SHIELD));
            }
            inventory.addItem(new ItemStack(Material.DIAMOND_SWORD),
                    new ItemStack(Material.DIAMOND_AXE),
                    new ItemStack(Material.DIAMOND_PICKAXE),
                    new ItemStack(Material.END_STONE, 64),
                    new ItemStack(Material.END_STONE, 64),
                    new ItemStack(Material.END_STONE, 64),
                    new ItemStack(Material.END_STONE, 64),
                    new ItemStack(Material.END_STONE, 64),
                    new ItemStack(Material.BOW),
                    new ItemStack(Material.ARROW, 64),
                    new ItemStack(Material.ARROW, 64)
            );
        }
    }
}
