package cn.wzpmc.hny.events;

import cn.wzpmc.hny.games.PlayerDataManager;
import cn.wzpmc.hny.games.PlayerEffectManager;
import net.kyori.adventure.text.Component;
import org.bukkit.entity.Entity;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.EntityDamageByEntityEvent;

import java.util.Random;
import java.util.concurrent.TimeUnit;

public class PlayerDamage implements Listener {
    @EventHandler
    public void onPlayerDamage(EntityDamageByEntityEvent event){
        Entity entity = event.getEntity();
        Entity damager = event.getDamager();
        if (event.getEntityType().equals(EntityType.PLAYER)) {
            Player player = (Player) entity;
            if (PlayerDeath.putOffs.containsKey(player)){
                event.setCancelled(true);
                return;
            }
            PlayerEffectManager effectManager = PlayerEffectManager.getInstance();
            double finalDamage = event.getFinalDamage();
            double playerHealth = player.getHealth();
            if (effectManager.hasEffect(player, PlayerEffectManager.Effects.RAINBOW_HEALTH)) {
                event.setDamage(0);
                double health = playerHealth;
                health += finalDamage / 2;
                if (health > 20){
                    health = 20;
                }
                player.setHealth(health);
                effectManager.removeEffect(player, PlayerEffectManager.Effects.RAINBOW_HEALTH);
            }
            if (effectManager.hasEffect(player, PlayerEffectManager.Effects.POWER_WELDING)){
                event.setDamage(finalDamage * 2);
                player.damage(finalDamage, damager);
                effectManager.removeEffect(player, PlayerEffectManager.Effects.POWER_WELDING);
            }
            if (damager instanceof Player attacker){
                if (effectManager.hasEffect(attacker, PlayerEffectManager.Effects.BADLY_HURT)){
                    effectManager.addEffect(player, PlayerEffectManager.Effects.BE_BADLY_HURT, 5, TimeUnit.SECONDS);
                    effectManager.removeEffect(attacker, PlayerEffectManager.Effects.BADLY_HURT);
                }
                if (effectManager.hasEffect(attacker, PlayerEffectManager.Effects.CODE)){
                    if (effectManager.hasEffect(player, PlayerEffectManager.Effects.ERROR)){
                        attacker.sendMessage(Component.text("被攻击对象已有异常效果"));
                    }else {
                        effectManager.addEffect(player, PlayerEffectManager.Effects.ERROR, 1, TimeUnit.DAYS);
                    }
                    effectManager.removeEffect(player, PlayerEffectManager.Effects.CODE);
                }
                if (effectManager.hasEffect(attacker, PlayerEffectManager.Effects.ERROR)){
                    if (new Random().nextDouble() < 0.75) {
                        event.setDamage(0);
                    }
                    effectManager.removeEffect(player);
                }
            }
        }
        if (damager instanceof Player player){
            if (entity.getScoreboardTags().stream().anyMatch(e -> e.equals("boss1"))) {
                PlayerDataManager instance = PlayerDataManager.getInstance();
                instance.getPlayerData(player).addMoney(10);
                instance.savePlayerData(player);
            }
        }
    }
}
