package cn.wzpmc.hny.events;

import cn.wzpmc.hny.games.GameStageManager;
import cn.wzpmc.hny.games.PlayerDataManager;
import cn.wzpmc.hny.games.enums.Games;
import cn.wzpmc.hny.pojo.CustomItem;
import cn.wzpmc.hny.pojo.GlobalPlayerData;
import cn.wzpmc.hny.utils.ClickEventRegister;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.event.ClickEvent;
import net.kyori.adventure.text.format.NamedTextColor;
import org.bukkit.entity.HumanEntity;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.InventoryView;
import org.bukkit.inventory.ItemStack;

import java.util.Map;

public class PlayerInventoryClick implements Listener {
    @EventHandler
    public void onPlayerInventoryClick(InventoryClickEvent event){
        InventoryView view = event.getView();
        HumanEntity human = view.getPlayer();
        Component title = view.title();
        ItemStack cursor = event.getCurrentItem();
        if (cursor == null){
            return;
        }
        if (human instanceof Player player){
            if (title.equals(PlayerDataManager.PLAYER_STATISTICAL_INVENTORY_TITLE)){
                if (CustomItem.ProjectItemStatic.INTO_INVENTORY_BUTTON.is(cursor)) {
                    PlayerDataManager.getInstance().showPlayerInventory(player);
                }
                event.setCancelled(true);
                return;
            }
            if (title.equals(PlayerDataManager.PLAYER_INVENTORY_TITLE)){
                if (CustomItem.ProjectItemStatic.INVENTORY_BACK_BUTTON.is(cursor)){
                    PlayerDataManager.getInstance().showPlayerData(player);
                }
                for (Map.Entry<CustomItem, ClickEventRegister.ClickEvent> customItemClickEventEntry : ClickEventRegister.getClickEvents().entrySet()) {
                    CustomItem key = customItemClickEventEntry.getKey();
                    if (key.is(cursor)) {
                        if (GameStageManager.getInstance().isStart(Games.GAME5)){
                            customItemClickEventEntry.getValue().onClick(key, event);
                        }else {
                            player.sendMessage(Component.text("道具仅在第五阶段可用"));
                        }
                        break;
                    }
                }
                event.setCancelled(true);
                return;
            }
            if (CustomItem.ItemStatic.FU_CARD.is(cursor)){
                event.setCurrentItem(null);
                PlayerDataManager instance = PlayerDataManager.getInstance();
                GlobalPlayerData playerData = instance.getPlayerData(player);
                if (playerData.getInventory().stream().anyMatch(e -> e.getType().equals(CustomItem.ItemStatic.FU_CARD))){
                    human.sendMessage(Component.text("福卡已存在，不可重复获取！").color(NamedTextColor.RED));
                    return;
                }
                playerData.addItem(CustomItem.ItemStatic.FU_CARD);
                instance.savePlayerData(player);
                human.sendMessage(Component.text("道具福卡已添加至你的道具仓库"));
            }
        }

    }
}
