package cn.wzpmc.hny.events;

import cn.wzpmc.hny.games.DigGame;
import cn.wzpmc.hny.games.GameStageManager;
import cn.wzpmc.hny.games.MazeDataManager;
import cn.wzpmc.hny.games.SumoGame;
import cn.wzpmc.hny.games.enums.Games;
import cn.wzpmc.hny.pojo.BoxPosition;
import cn.wzpmc.hny.utils.Wind;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import net.kyori.adventure.title.Title;
import org.bukkit.GameMode;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerMoveEvent;
import org.bukkit.potion.PotionEffectType;

import java.util.HashMap;
import java.util.Map;

public class PlayerMove implements Listener {
    @EventHandler
    public void onPlayerMove(PlayerMoveEvent event){
        Player player = event.getPlayer();
        Location moveTo = event.getTo();
        World world = moveTo.getWorld();
        String name = world.getName();
        if (name.equals("maze")){
            Location add = moveTo.clone().add(0, -1, 0);
            if (add.getBlock().getType().equals(Material.WHITE_GLAZED_TERRACOTTA)){
                if (player.getGameMode().equals(GameMode.ADVENTURE)){
                    MazeDataManager.getInstance().winPlayer(player);
                }
            }
        }
        for (Wind value : Wind.winds.values()) {
            if (value.isPointIn(moveTo)) {
                value.onPlayerIn(player);
            } else {
                if (player.getActivePotionEffects().stream().anyMatch(e -> e.getType().equals(PotionEffectType.LEVITATION))) {
                    player.removePotionEffect(PotionEffectType.LEVITATION);
                }
            }
        }
        if (DigGame.isPlayerInGame(player)){
            if (moveTo.y() <= 40){
                DigGame playerGame = DigGame.getPlayerGame(player);
                assert playerGame != null;
                playerGame.losePlayer(player);
            }
        }
        if (moveTo.y() <= 50){
            SumoGame.losePlayer(player);

        }
        if (!name.equals("game1")) {
            return;
        }
        if (moveTo.getBlockY() <= 144){
            return;
        }
        GameMode gameMode = player.getGameMode();
        if (gameMode.equals(GameMode.CREATIVE) || gameMode.equals(GameMode.SPECTATOR)) {
            return;
        }
        if (world.getBlockAt(moveTo.getBlockX(), moveTo.getBlockY() - 1, moveTo.getBlockZ()).isEmpty()){
            return;
        }
        if (player.isJumping()){
            return;
        }
        for (Games value : Games.values()) {
            if (GameStageManager.getInstance().isUnlock(value)){
                continue;
            }
            BoxPosition boxPosition = value.getBoxPosition();
            if (boxPosition.isIn(moveTo)){
                player.showTitle(Title.title(Component.text("未解锁的区域").color(NamedTextColor.YELLOW), Component.text("前面的区域，以后再来探索吧").color(NamedTextColor.GREEN)));
                Location nearestEdgePoint = boxPosition.getNearestEdgePoint(moveTo);
                if (moveTo.y() < 150){
                    nearestEdgePoint.setY(144);
                }
                player.teleport(nearestEdgePoint);
                break;
            }
        }
    }
}
