package cn.wzpmc.hny.events;

import cn.wzpmc.hny.HappyNewLobby;
import cn.wzpmc.hny.games.DigGame;
import cn.wzpmc.hny.games.GameStageManager;
import cn.wzpmc.hny.games.PlayerDataManager;
import cn.wzpmc.hny.games.PlayerEffectManager;
import cn.wzpmc.hny.games.enums.Games;
import cn.wzpmc.hny.games.enums.Teams;
import cn.wzpmc.hny.pojo.CustomItem;
import cn.wzpmc.hny.pojo.GlobalPlayerData;
import cn.wzpmc.hny.utils.Wind;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import net.kyori.adventure.title.Title;
import org.bukkit.*;
import org.bukkit.block.Block;
import org.bukkit.entity.*;
import org.bukkit.inventory.ItemStack;
import org.bukkit.persistence.PersistentDataContainer;
import org.bukkit.persistence.PersistentDataType;
import org.bukkit.potion.PotionEffect;
import org.bukkit.potion.PotionEffectType;
import org.bukkit.scheduler.BukkitRunnable;
import org.bukkit.scoreboard.Scoreboard;
import org.bukkit.scoreboard.ScoreboardManager;
import org.bukkit.scoreboard.Team;

import java.time.Duration;
import java.util.*;

import static cn.wzpmc.hny.games.PlayerEffectManager.Effects.*;
public class Tick extends BukkitRunnable {
    private final Server server;
    private byte ticks = 0;
    private final Map<Player, Integer> playerInEndTicks = new HashMap<>();
    public Tick(){
        this.server = HappyNewLobby.getPlugin(HappyNewLobby.class).getServer();
    }
    @Override
    public void run() {
        PlayerEffectManager effectManager = PlayerEffectManager.getInstance();
        effectManager.onTick();
        GameStageManager instance = GameStageManager.getInstance();
        PlayerDataManager playerDataManager = PlayerDataManager.getInstance();
        Collection<? extends Player> onlinePlayers = server.getOnlinePlayers();
        for (Map.Entry<Player, Long> playerLongEntry : PlayerDeath.putOffs.entrySet()) {
            if (playerLongEntry.getValue() < System.currentTimeMillis()){
                Player key = playerLongEntry.getKey();
                key.damage(key.getHealth());
                PlayerDeath.putOffs.remove(key);
            }
        }
        for (Player onlinePlayer : onlinePlayers) {
            if (effectManager.hasEffect(onlinePlayer, DISH)){
                effectManager.hideEffect(onlinePlayer, BE_BADLY_HURT);
                effectManager.hideEffect(onlinePlayer, ERROR);
                effectManager.hideEffect(onlinePlayer, MARK);
            }
            if (effectManager.hasEffect(onlinePlayer, BE_BADLY_HURT)){
                onlinePlayer.addPotionEffect(new PotionEffect(PotionEffectType.WEAKNESS, 20, 1, false));
            }
            if (effectManager.hasEffect(onlinePlayer, TREAT)){
                String tickString = effectManager.getEffectAttr(onlinePlayer, TREAT, "tick");
                int tick = tickString == null ? 0 : Integer.parseInt(tickString);
                onlinePlayer.addPotionEffect(new PotionEffect(PotionEffectType.SLOW, 20, 3, false));
                double health = onlinePlayer.getHealth();
                if (tick == 100){
                    if (health >= 15){
                        onlinePlayer.setHealth(20);
                    }else {
                        onlinePlayer.setHealth(health + 5);
                    }
                    effectManager.removeEffect(onlinePlayer, BE_BADLY_HURT);
                }
                if (tick == 140){
                    if (health >= 19){
                        onlinePlayer.setHealth(20);
                    } else {
                        onlinePlayer.setHealth(health + 1);
                    }
                    effectManager.removeEffect(onlinePlayer, BE_BADLY_HURT);
                    effectManager.removeEffect(onlinePlayer, ERROR);

                }
                if (tick == 200) {
                    if (health >= 16){
                        onlinePlayer.setHealth(20);
                    }else {
                        onlinePlayer.setHealth(health + 10);
                    }
                    effectManager.removeEffect(onlinePlayer, BE_BADLY_HURT);
                    effectManager.removeEffect(onlinePlayer, ERROR);
                    effectManager.removeEffect(onlinePlayer, MARK);
                }
                tick++;
                effectManager.setEffectAttr(onlinePlayer, TREAT, "tick", tick);
            }
            if (effectManager.hasEffect(onlinePlayer, TURBINE)){
                onlinePlayer.addPotionEffect(new PotionEffect(PotionEffectType.JUMP, 20,1, false));
                onlinePlayer.addPotionEffect(new PotionEffect(PotionEffectType.SPEED, 20, 2, false));
            }
        }
        for (Games value : Games.values()) {
            if (instance.isNotStart(value) && instance.isUnlock(value)) {
                int size = instance.getVotePlayers(value).size();
                if (size > 0){
                    int playersCount = onlinePlayers.size();
                    if (playersCount / 2f <= size){
                        for (Player onlinePlayer : onlinePlayers) {
                            onlinePlayer.showTitle(Title.title(
                                    Component.text("投票成功，正在加入游戏~").color(NamedTextColor.GOLD),
                                    Component.empty(),
                                    Title.Times.times(Duration.ZERO, Duration.ofMillis(1000), Duration.ofMillis(500))
                            ));
                        }
                        instance.triggerGameStart(value);
                        continue;
                    }
                    for (Player onlinePlayer : onlinePlayers) {
                        onlinePlayer.showTitle(Title.title(
                                Component.text("有玩家发起了游戏投票(")
                                        .append(Component.text(size))
                                        .append(Component.text("/"))
                                        .append(Component.text(playersCount))
                                        .append(Component.text(")")),
                                Component.text("人数超过一半就会开始游戏"),
                                Title.Times.times(Duration.ZERO, Duration.ofMillis(500), Duration.ZERO)
                        ));
                    }
                }
            }
        }
        for (Wind value : Wind.winds.values()) {
            value.drawParticle();
        }
        for (Player player: server.getOnlinePlayers()){
            player.removePotionEffect(PotionEffectType.FAST_DIGGING);
        }
        for (DigGame game : DigGame.games) {
            if (game.isClosed()){
                continue;
            }
            World cbWorld = game.getPlayWorld().getCBWorld();
            Collection<Item> entitiesByClass = cbWorld.getEntitiesByClass(Item.class);
            for (Item item : entitiesByClass) {
                ItemStack itemStack = item.getItemStack();
                if (DigGame.isSpecialShovel(itemStack)){
                    Location location = item.getLocation();
                    for (int x = -1; x < 1; x++) {
                        for (int y = -1; y < 1; y++) {
                            for (int z = -1; z < 1; z++) {
                                Location clone = location.clone();
                                Location add = clone.add(x, y, z);
                                Block block = add.getBlock();
                                Material blockType = block.getType();
                                if (blockType.equals(Material.POWDER_SNOW) || blockType.equals(Material.SNOW_BLOCK)){
                                    block.setType(Material.AIR);
                                }
                            }
                        }
                    }
                }
            }
            for (Player player : game.getPlayers().keySet()) {
                player.addPotionEffect(new PotionEffect(PotionEffectType.FAST_DIGGING, 20,255,false));
            }
        }
        World world = server.getWorld("world_the_end");
        if (world != null){
            for (EnderDragon entitiesByClass : world.getEntitiesByClass(EnderDragon.class)) {
                LivingEntity target = entitiesByClass.getTarget();
                if (target instanceof Player player) {
                    if (PlayerDataManager.getInstance().getPlayerData(player).getTeam().equals(Teams.PROTECT)) {
                        entitiesByClass.setTarget(null);
                    }
                }
            }
            for (EnderCrystal entitiesByClass : world.getEntitiesByClass(EnderCrystal.class)) {
                PersistentDataContainer persistentDataContainer = entitiesByClass.getPersistentDataContainer();
                long[] uuidBits = persistentDataContainer.get(CustomItem.ItemStatic.EVOLUTION_CRYSTAL_PLAYER_KEY, PersistentDataType.LONG_ARRAY);
                if (uuidBits == null){
                    continue;
                }
                UUID uuid = new UUID(uuidBits[0], uuidBits[1]);
                Player player = server.getPlayer(uuid);
                if (player == null){
                    continue;
                }
                if (ticks == 20){
                    double nowHealth = player.getHealth();
                    if (nowHealth < 19){
                        player.setHealth(nowHealth + 1);
                    }else if (nowHealth < 20){
                        player.setHealth(20);
                    }
                }
            }
            for (Player player : world.getPlayers()) {
                Integer tickTimes = playerInEndTicks.getOrDefault(player, 0);
                tickTimes ++;
                if (tickTimes == 1200){
                    tickTimes = 0;
                    GlobalPlayerData playerData = playerDataManager.getPlayerData(player);
                    playerData.addErosionLevel(0.5);
                    double erosionLevel = playerData.getErosionLevel();
                    if (erosionLevel > 95){
                        player.showTitle(Title.title(Component.text("你被末影侵蚀了！").color(NamedTextColor.DARK_GREEN), Component.text("你现在与末影龙一方！")));
                        playerData.setTeam(Teams.PROTECT);
                        playerDataManager.savePlayerData(player);
                    }
                    playerDataManager.savePlayerData(player);
                }
                playerInEndTicks.put(player, tickTimes);
            }
        }
        if (ticks == 20){
            ticks = 0;
        }
        ticks ++;
    }
}
