package cn.wzpmc.hny.games.events.impl;

import cn.wzpmc.hny.games.GameStageManager;
import cn.wzpmc.hny.games.enums.Games;
import cn.wzpmc.hny.games.events.StageEvent;
import cn.wzpmc.hny.utils.BetterBukkitRunnable;
import cn.wzpmc.hny.utils.EntityUtils;
import cn.wzpmc.hny.utils.MessageBroadcast;
import com.onarandombox.MultiverseCore.MultiverseCore;
import com.onarandombox.MultiverseCore.api.MVWorldManager;
import com.onarandombox.MultiverseCore.api.MultiverseWorld;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import net.kyori.adventure.text.format.TextDecoration;
import net.kyori.adventure.title.Title;
import org.bukkit.GameMode;
import org.bukkit.Location;
import org.bukkit.World;
import org.bukkit.attribute.Attribute;
import org.bukkit.attribute.AttributeInstance;
import org.bukkit.entity.*;
import org.bukkit.plugin.Plugin;
import org.bukkit.plugin.PluginManager;
import org.bukkit.potion.PotionEffect;
import org.bukkit.potion.PotionEffectType;

import java.util.Collection;

public class Game2StageEvent extends StageEvent {
    public Game2StageEvent() {
        super(Games.GAME2, Games.GAME3);
    }
    @Override
    public void onStageStart() {
        PluginManager pluginManager = server.getPluginManager();
        MultiverseCore mv = (MultiverseCore) pluginManager.getPlugin("Multiverse-Core");
        assert mv != null;
        MVWorldManager mvWorldManager = mv.getMVWorldManager();
        MultiverseWorld bossWorld = mvWorldManager.getMVWorld("boss1");
        World cbWorld = bossWorld.getCBWorld();
        Location location = new Location(cbWorld, 50, 73, 61);
        Collection<? extends Player> onlinePlayers = server.getOnlinePlayers();
        for (Entity entity : cbWorld.getEntities()) {
            entity.remove();
        }
        for (Player onlinePlayer : onlinePlayers) {
            onlinePlayer.teleport(location);
            onlinePlayer.setBedSpawnLocation(location, true);
            onlinePlayer.setHealth(20);
            onlinePlayer.addPotionEffect(new PotionEffect(PotionEffectType.SATURATION, 10000000, 255, false));
        }
        new MessageBroadcast(Title.title(Component.text("准备好了吗？"), Component.empty()), onlinePlayers).runTaskLater(this.plugin, 40);
        new MessageBroadcast(Title.title(Component.text("BOSS来袭！"), Component.empty()), onlinePlayers).runTaskLater(this.plugin, 80);
        new BetterBukkitRunnable(() -> {
            Evoker ravager = cbWorld.spawn(location, Evoker.class);
            ravager.addScoreboardTag("boss1");
            ravager.customName(Component.text("鬼道人").color(NamedTextColor.GOLD).decorate(TextDecoration.BOLD, TextDecoration.UNDERLINED));
            EntityUtils.modifyValue(ravager, Attribute.GENERIC_ATTACK_DAMAGE, 5);
            EntityUtils.modifyValue(ravager, Attribute.GENERIC_MAX_HEALTH, 50);
            EntityUtils.modifyValue(ravager, Attribute.GENERIC_FOLLOW_RANGE, 100);
            EntityUtils.modifyValue(ravager, Attribute.GENERIC_ARMOR, 5);
            EntityUtils.modifyValue(ravager, Attribute.GENERIC_ARMOR_TOUGHNESS, 1);
            EntityUtils.addEffects(ravager, PotionEffectType.HEALTH_BOOST, 1);
            ravager.setHealth(50);
            Ravager entity = cbWorld.spawn(location, Ravager.class);
            entity.addScoreboardTag("boss1");
            entity.customName(Component.text("撒克诺尔").color(NamedTextColor.DARK_PURPLE).decorate(TextDecoration.BOLD, TextDecoration.UNDERLINED));
            EntityUtils.modifyValue(entity, Attribute.GENERIC_ATTACK_DAMAGE, 5);
            EntityUtils.modifyValue(entity, Attribute.GENERIC_MAX_HEALTH, 100);
            EntityUtils.modifyValue(entity, Attribute.GENERIC_MOVEMENT_SPEED, 2);
            EntityUtils.modifyValue(entity, Attribute.GENERIC_KNOCKBACK_RESISTANCE, 1);
            EntityUtils.modifyValue(entity, Attribute.GENERIC_FOLLOW_RANGE, 50);
            EntityUtils.modifyValue(entity, Attribute.GENERIC_ARMOR, 30);
            EntityUtils.modifyValue(entity, Attribute.GENERIC_ARMOR_TOUGHNESS, 2);
            EntityUtils.addEffects(entity, PotionEffectType.HEALTH_BOOST, 1);
            entity.setCustomNameVisible(true);
            entity.setGlowing(true);
            entity.setPersistent(true);
            entity.setHealth(100);
            entity.addPassenger(ravager);
        }).runTaskLater(this.plugin, 80);
    }

    @Override
    public void onStageDone() {
        super.onStageDone();
    }
}
