package cn.wzpmc.hny.games.events.impl;

import cn.wzpmc.hny.errors.WorldCreateException;
import cn.wzpmc.hny.games.DigGame;
import cn.wzpmc.hny.games.GameStageManager;
import cn.wzpmc.hny.games.PlayerDataManager;
import cn.wzpmc.hny.games.enums.Games;
import cn.wzpmc.hny.games.events.StageEvent;
import cn.wzpmc.hny.pojo.RankablePlayerData;
import cn.wzpmc.hny.pojo.GlobalPlayerData;
import cn.wzpmc.hny.utils.BetterBukkitRunnable;
import org.bukkit.GameMode;
import org.bukkit.Location;
import org.bukkit.World;
import org.bukkit.entity.Player;

import java.util.Comparator;
import java.util.Map;
import java.util.Set;
import java.util.concurrent.atomic.AtomicInteger;

public class Game3StageEvent extends StageEvent {
    public Game3StageEvent() {
        super(Games.GAME3, Games.GAME4);
    }
    private DigGame digGame;
    @Override
    public void onStageStart() {
        try {
            this.digGame = new DigGame();
            this.digGame.prepare();
        } catch (WorldCreateException e) {
            throw new RuntimeException(e);
        }
    }

    @Override
    public void onStageDone() {
        super.onStageDone();
        Map<Player, RankablePlayerData> players = this.digGame.getPlayers();
        Set<Map.Entry<Player, RankablePlayerData>> entries = players.entrySet();
        AtomicInteger i = new AtomicInteger();
        entries.stream().sorted(Comparator.comparing(e -> e.getValue().getRank(), Comparator.reverseOrder())).forEachOrdered(e -> {
            Player key = e.getKey();
            PlayerDataManager instance = PlayerDataManager.getInstance();
            GlobalPlayerData playerData = instance.getPlayerData(key);
            playerData.addMoney(i.getAndAdd(100));
            instance.savePlayerData(key);
        });
        new BetterBukkitRunnable(() -> this.digGame.close()).runTaskLater(this.plugin, 100);
    }
}
