package cn.wzpmc.hny.utils;

import org.mmga.utils.utils.map.IncreaseAbleMap;

import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.function.Consumer;

public class IncreaseAbleConcurrentHashMap<K, V> extends ConcurrentHashMap<K, CopyOnWriteArrayList<V>> implements IncreaseAbleMap<K, V> {
    @Override
    public void add(K k, V v) {
        CopyOnWriteArrayList<V> vs = super.getOrDefault(k, new CopyOnWriteArrayList<>());
        vs.add(v);
        super.put(k, vs);
    }

    @Override
    public boolean delete(K k, V v) {
        CopyOnWriteArrayList<V> oldList = super.getOrDefault(k, new CopyOnWriteArrayList<>());
        if (!oldList.remove(v)) {
            return false;
        } else {
            super.put(k, oldList);
            return true;
        }
    }

    @Override
    public void forEach(K k, Consumer<? super V> consumer) {
        super.get(k).forEach(consumer);
    }
}
