package cn.wzpmc.hny.utils;

import cn.wzpmc.hny.games.GameStageManager;
import cn.wzpmc.hny.games.enums.Games;
import cn.wzpmc.hny.games.events.StageEvent;
import org.bukkit.GameMode;
import org.bukkit.Location;
import org.bukkit.Server;
import org.bukkit.World;
import org.bukkit.entity.Player;
import org.bukkit.scheduler.BukkitRunnable;

public class StageDoneTask extends BukkitRunnable {
    private final Location location;
    private final Server server;
    private final World game1World;
    private final Games game;
    private final Games nextGame;
    public StageDoneTask(StageEvent stageEvent, double x, double y, double z, float yaw, float pitch){
        this.server = stageEvent.getServer();
        this.game1World = server.getWorld("game1");
        this.location = new Location(game1World, x,y,z,yaw,pitch);
        this.game = stageEvent.getGame();
        this.nextGame = stageEvent.getNextGame();
    }
    public StageDoneTask(StageEvent stageEvent, double x, double y, double z){
        this.server = stageEvent.getServer();
        this.game1World = server.getWorld("game1");
        this.location = new Location(game1World, x,y,z);
        this.game = stageEvent.getGame();
        this.nextGame = stageEvent.getNextGame();
    }
    @Override
    public void run() {
        for (Player onlinePlayer : server.getOnlinePlayers()) {
            onlinePlayer.setGameMode(GameMode.ADVENTURE);
            onlinePlayer.teleport(location);
            onlinePlayer.setBedSpawnLocation(location, true);
            onlinePlayer.getInventory().clear();
        }
        this.game.getBoxPosition().triggerRedstoneLamp(game1World, true);
        GameStageManager.getInstance().setUnlock(this.nextGame, true);
    }
}
