package cn.wzpmc.hny.utils;

import com.destroystokyo.paper.ParticleBuilder;
import com.mojang.brigadier.context.CommandContext;
import com.mojang.brigadier.exceptions.CommandSyntaxException;
import com.mojang.brigadier.suggestion.SuggestionProvider;
import com.mojang.brigadier.suggestion.Suggestions;
import com.mojang.brigadier.suggestion.SuggestionsBuilder;
import org.bukkit.Color;
import org.bukkit.Location;
import org.bukkit.World;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.potion.PotionEffect;
import org.bukkit.potion.PotionEffectType;

import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.CompletableFuture;

public class Wind {
    public static final Map<String, Wind> winds = new HashMap<>();
    private final Location center;
    private final double radius;
    private final double topY;
    private double nowY;
    private final int power;
    public Wind(Location center, double topY, double radius, int power){
        this.center = center;
        this.radius = radius;
        this.power = power;
        this.topY = topY;
        this.nowY = center.y();
    }
    public void spawn(String name){
        winds.put(name, this);
    }

    public void drawParticle(){
        nowY += 1;
        if (nowY >= topY){
            nowY = this.center.y();
        }
        Location clone = this.center.clone();
        clone.setY(nowY);
        ParticleUtils.drawCircleParticle(clone, this.radius, Color.WHITE);
    }
    public boolean isPointIn(Location location){
        double x = location.x();
        double y = location.y();
        double z = location.z();
        double centerX = this.center.x();
        double centerY = this.center.y();
        double centerZ = this.center.z();
        if (!location.getWorld().equals(this.center.getWorld())){
            return false;
        }
        if (!(Math.sqrt(Math.pow(x - centerX, 2) + Math.pow(z - centerZ, 2)) <= radius)) {
            return false;
        }
        if (y < centerY){
            return false;
        }
        return !(y > topY);
    }
    public void onPlayerIn(Player player){
        player.addPotionEffect(new PotionEffect(PotionEffectType.LEVITATION, 20, this.power, false));
    }
    public static class WindSuggestion implements SuggestionProvider<CommandSender>{

        @Override
        public CompletableFuture<Suggestions> getSuggestions(CommandContext<CommandSender> commandContext, SuggestionsBuilder suggestionsBuilder) throws CommandSyntaxException {
            winds.keySet().forEach(suggestionsBuilder::suggest);
            return suggestionsBuilder.buildFuture();
        }
    }
}
